import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeStackInstanceInput, DescribeStackInstanceOutput } from "../models/models_0";
import { deserializeAws_queryDescribeStackInstanceCommand, serializeAws_queryDescribeStackInstanceCommand, } from "../protocols/Aws_query";
var DescribeStackInstanceCommand = (function (_super) {
    __extends(DescribeStackInstanceCommand, _super);
    function DescribeStackInstanceCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeStackInstanceCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudFormationClient";
        var commandName = "DescribeStackInstanceCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeStackInstanceInput.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeStackInstanceOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeStackInstanceCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryDescribeStackInstanceCommand(input, context);
    };
    DescribeStackInstanceCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryDescribeStackInstanceCommand(output, context);
    };
    return DescribeStackInstanceCommand;
}($Command));
export { DescribeStackInstanceCommand };
