import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeTypeRegistrationInput, DescribeTypeRegistrationOutput } from "../models/models_0";
import { deserializeAws_queryDescribeTypeRegistrationCommand, serializeAws_queryDescribeTypeRegistrationCommand, } from "../protocols/Aws_query";
var DescribeTypeRegistrationCommand = (function (_super) {
    __extends(DescribeTypeRegistrationCommand, _super);
    function DescribeTypeRegistrationCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeTypeRegistrationCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "CloudFormationClient";
        var commandName = "DescribeTypeRegistrationCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeTypeRegistrationInput.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeTypeRegistrationOutput.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeTypeRegistrationCommand.prototype.serialize = function (input, context) {
        return serializeAws_queryDescribeTypeRegistrationCommand(input, context);
    };
    DescribeTypeRegistrationCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_queryDescribeTypeRegistrationCommand(output, context);
    };
    return DescribeTypeRegistrationCommand;
}($Command));
export { DescribeTypeRegistrationCommand };
