import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CloudFormationClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CloudFormationClient";
import { ActivateTypeInput, ActivateTypeOutput } from "../models/models_0";
export interface ActivateTypeCommandInput extends ActivateTypeInput {
}
export interface ActivateTypeCommandOutput extends ActivateTypeOutput, __MetadataBearer {
}

export declare class ActivateTypeCommand extends $Command<ActivateTypeCommandInput, ActivateTypeCommandOutput, CloudFormationClientResolvedConfig> {
    readonly input: ActivateTypeCommandInput;
    constructor(input: ActivateTypeCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CloudFormationClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ActivateTypeCommandInput, ActivateTypeCommandOutput>;
    private serialize;
    private deserialize;
}
