import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CloudFormationClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CloudFormationClient";
import { DescribeTypeInput, DescribeTypeOutput } from "../models/models_0";
export interface DescribeTypeCommandInput extends DescribeTypeInput {
}
export interface DescribeTypeCommandOutput extends DescribeTypeOutput, __MetadataBearer {
}

export declare class DescribeTypeCommand extends $Command<DescribeTypeCommandInput, DescribeTypeCommandOutput, CloudFormationClientResolvedConfig> {
    readonly input: DescribeTypeCommandInput;
    constructor(input: DescribeTypeCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CloudFormationClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DescribeTypeCommandInput, DescribeTypeCommandOutput>;
    private serialize;
    private deserialize;
}
