import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CloudFormationClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CloudFormationClient";
import { GetStackPolicyInput, GetStackPolicyOutput } from "../models/models_0";
export interface GetStackPolicyCommandInput extends GetStackPolicyInput {
}
export interface GetStackPolicyCommandOutput extends GetStackPolicyOutput, __MetadataBearer {
}

export declare class GetStackPolicyCommand extends $Command<GetStackPolicyCommandInput, GetStackPolicyCommandOutput, CloudFormationClientResolvedConfig> {
    readonly input: GetStackPolicyCommandInput;
    constructor(input: GetStackPolicyCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CloudFormationClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetStackPolicyCommandInput, GetStackPolicyCommandOutput>;
    private serialize;
    private deserialize;
}
