import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CloudFormationClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CloudFormationClient";
import { TestTypeInput, TestTypeOutput } from "../models/models_0";
export interface TestTypeCommandInput extends TestTypeInput {
}
export interface TestTypeCommandOutput extends TestTypeOutput, __MetadataBearer {
}

export declare class TestTypeCommand extends $Command<TestTypeCommandInput, TestTypeCommandOutput, CloudFormationClientResolvedConfig> {
    readonly input: TestTypeCommandInput;
    constructor(input: TestTypeCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CloudFormationClientResolvedConfig, options?: __HttpHandlerOptions): Handler<TestTypeCommandInput, TestTypeCommandOutput>;
    private serialize;
    private deserialize;
}
