export default function flatten(obj) {
    var toReturn = {};
    for (var i in obj) {
        if (!obj.hasOwnProperty(i)) {
            continue;
        }
        if (typeof obj[i] === 'object' && obj[i] !== null) {
            var flatObject = flatten(obj[i]);
            for (var x in flatObject) {
                if (!flatObject.hasOwnProperty(x)) {
                    continue;
                }
                // Make a bracket array notation like some[1].array[0]
                var key = (i + "." + x).split('.').reduce(function (str, value) {
                    if (/^\[\d\]/.test(value)) {
                        return "" + str + value;
                    }
                    if (!isNaN(Number(value))) {
                        return str + "[" + value + "]";
                    }
                    if (str) {
                        return str + "." + value;
                    }
                    return value;
                }, '');
                toReturn[key] = flatObject[x];
            }
        }
        else {
            toReturn[i] = obj[i];
        }
    }
    return toReturn;
}
